---
import { getCategories } from "@/products/services/CategoriesService";
import BtnCategory from "@/products/components/filters-products/category-filter/btn-category/BtnCategory.astro";
import MoopSvg from "@/shared/svgs/MoopSvg.astro";

const { categories } = await getCategories();

const url = new URL(Astro.request.url);

const categorySelected = new URLSearchParams(url.searchParams).get("category");
---

<nav class="flex flex-col items-start my-4 w-full">
  {
    categories.map((category) => (
      <BtnCategory
        id={category.id}
        name={category.name}
        selected={category.id === Number(categorySelected)}
      >
        {category.name}
      </BtnCategory>
    ))
  }
  <button
    type="button"
    disabled={!categorySelected}
    class="flex items-center text-violet-400 hover:text-violet-500 disabled:text-gray-400 font-semibold mt-4 w-full"
    onclick="handleCleanFilters()"
  >
    <MoopSvg size={20} color={categorySelected ? "rgb(167,139,250)" : "rgb(156,163,175)"} />
    <span class="ml-2">Clean category</span>
  </button>
</nav>

<script is:inline>
  function handleCleanFilters() {
    const lastQueryParams = new URLSearchParams(window.location.search);
    const queryParams = new URLSearchParams();
    const lastSearch = lastQueryParams.get("search");
    if (lastSearch) queryParams.set("search", lastSearch);
    if (lastQueryParams.get("limit")) queryParams.set("limit", lastQueryParams.get("limit"));
    queryParams.delete("category");
    window.location.search = queryParams;
  }
</script>
